// imgstamp_test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <string.h>
#include <stdio.h>

typedef long (__stdcall *ImageStampOpenFunc)(char *In,char *Out);
typedef void (__stdcall *ImageStampCloseFunc)(long id);
typedef long (__stdcall *ImageStampAddTextFunc)( long id, int x, int y, char *m_text,long color,LOGFONT m_font,int style);
typedef long (__stdcall *ImageStampAddImageFunc)(long id,int x,int y, int width, int height,char *filename,BOOL bTransparent);
typedef long (__stdcall *ImageStampGetInfoFunc)(long id,LPBITMAPINFOHEADER lpbi);
typedef long (__stdcall *ImageStampPrintFunc)(long id,const char *ptrPrintName,long dmOrientation, long dmPaperSize,long dmCopies);
typedef long (__stdcall *ImageStampPrintExFunc)(long id,const char *ptrPrintName,long dmOrientation, long dmPaperSize,long dmCopies, int bShellPrint);
typedef long (__stdcall *ImageStampSetPageRangeFunc)(long id, char *lpPageRange);

typedef long (__stdcall *ImageStampCloseAndNotSaveFunc)(long id);
typedef long (__stdcall *ImageStampShowFunc)(long id,HDC hDC,RECT *rcDst, RECT *rcSrc);
typedef void (__stdcall *ImageStampSetLibDirectoryNameFunc)(const char *ptrLibDirectory);
typedef void (__stdcall *ImageStampAddLineFunc)(long id, int x0, int y0, int x1, int y1, int width,long color,int style);

typedef HDC  (__stdcall *ImageStampGetHDCFunc)(long id);
typedef long (__stdcall *ImageStampReleaseHDCFunc)(long id, HDC hDC);

typedef long (__stdcall *VeryShellPrintPDFFileFunc)(const char *lpPDFFileName,const char *ptrPrintName,
												long dmOrientation, long dmPaperSize,long dmCopies);
typedef long (__stdcall *VeryShellPrintPDFFileTimeOutFunc)(DWORD dwMilliseconds);
typedef long (__stdcall *VeryShellPrintPDFFileMarginsFunc)(long lMargins);

typedef long	(__stdcall *VeryRunCommand)(char *szCommand, long para1,long para2,char *para3,char *para4);
typedef int		(__stdcall *VeryGetPDFFileMediaBox)(const char *input, int pagenum,float *left,float *top, float *right, float *bottom);

/*
dmOrientation

	Selects the orientation of the paper. This member can be either DMORIENT_PORTRAIT 
	(1) or DMORIENT_LANDSCAPE (2).

dmPaperSize
	Selects the size of the paper to print on, the dmPaperSize member can 
	be set to one of the following predefined values: 

DMPAPER_LETTER		        Letter, 8 1/2 by 11 inches             																																		
DMPAPER_LEGAL		        Legal, 8 1/2 by 14 inches              																																		
DMPAPER_A4		        A4 Sheet, 210 by 297 millimeters       																																		
DMPAPER_CSHEET		        C Sheet, 17 by 22 inches               																																		
DMPAPER_DSHEET		        D Sheet, 22 by 34 inches               																																		
DMPAPER_ESHEET		        E Sheet, 34 by 44 inches               																																		
DMPAPER_LETTERSMALL	        Letter Small, 8 1/2 by 11 inches       																																		
DMPAPER_TABLOID		        Tabloid, 11 by 17 inches               																																		
DMPAPER_LEDGER		        Ledger, 17 by 11 inches                																																		
DMPAPER_STATEMENT	        Statement, 5 1/2 by 8 1/2 inches       																																		
DMPAPER_EXECUTIVE	        Executive, 7 1/4 by 10 1/2 inches      																																		
DMPAPER_A3		        A3 sheet, 297 by 420 millimeters       																																		
DMPAPER_A4SMALL		        A4 small sheet, 210 by 297 millimeters 																																		
DMPAPER_A5		        A5 sheet, 148 by 210 millimeters       																																		
DMPAPER_B4		        B4 sheet, 250 by 354 millimeters       																																		
DMPAPER_B5		        B5 sheet, 182-by-257-millimeter paper  																																		
DMPAPER_FOLIO		        Folio, 8-1/2-by-13-inch paper          																																		
DMPAPER_QUARTO		        Quarto, 215-by-275-millimeter paper    																																		
DMPAPER_10X14		        10-by-14-inch sheet                    																																		
DMPAPER_11X17		        11-by-17-inch sheet                    																																		
DMPAPER_NOTE		        Note, 8 1/2 by 11 inches               																																		
DMPAPER_ENV_9		        #9 Envelope, 3 7/8 by 8 7/8 inches     																																		
DMPAPER_ENV_10		        #10 Envelope, 4 1/8 by 9 1/2 inches    																																		
DMPAPER_ENV_11		        #11 Envelope, 4 1/2 by 10 3/8 inches   																																		
DMPAPER_ENV_12		        #12 Envelope, 4 3/4 by 11 inches       																																		
DMPAPER_ENV_14		        #14 Envelope, 5 by 11 1/2 inches       																																		
DMPAPER_ENV_DL		        DL Envelope, 110 by 220 millimeters    																																		
DMPAPER_ENV_C5		        C5 Envelope, 162 by 229 millimeters    																																		
DMPAPER_ENV_C3		        C3 Envelope,  324 by 458 millimeters   																																		
DMPAPER_ENV_C4		        C4 Envelope,  229 by 324 millimeters   																																		
DMPAPER_ENV_C6		        C6 Envelope,  114 by 162 millimeters   																																		
DMPAPER_ENV_C65		        C65 Envelope, 114 by 229 millimeters   																																		
DMPAPER_ENV_B4		        B4 Envelope,  250 by 353 millimeters   																																		
DMPAPER_ENV_B5		        B5 Envelope,  176 by 250 millimeters   																																		
DMPAPER_ENV_B6		        B6 Envelope,  176 by 125 millimeters   																																		
DMPAPER_ENV_ITALY	        Italy Envelope, 110 by 230 millimeters 																																		
DMPAPER_ENV_MONARCH	        Monarch Envelope, 3 7/8 by 7 1/2 inches																																		
DMPAPER_ENV_PERSONAL	        6 3/4 Envelope, 3 5/8 by 6 1/2 inches  																																		
DMPAPER_FANFOLD_US		US Std Fanfold, 14 7/8 by 11 inches
DMPAPER_FANFOLD_STD_GERMAN	German Std Fanfold, 8 1/2 by 12 inches
DMPAPER_FANFOLD_LGL_GERMAN	German Legal Fanfold, 8 1/2 by 13 inches 
*/

HMODULE							g_hVeryW=NULL;

ImageStampOpenFunc				ImageStampOpen;
ImageStampCloseFunc				ImageStampClose;
ImageStampAddTextFunc			ImageStampAddText;
ImageStampAddImageFunc			ImageStampAddImage;
ImageStampGetInfoFunc			ImageStampGetInfo;
ImageStampPrintFunc				ImageStampPrint;
ImageStampPrintExFunc     ImageStampPrintEx;
ImageStampSetPageRangeFunc		ImageStampSetPageRange;
ImageStampCloseAndNotSaveFunc	ImageStampCloseAndNotSave;
ImageStampShowFunc				ImageStampShow;
ImageStampSetLibDirectoryNameFunc	ImageStampSetLibDirectoryName;
ImageStampAddLineFunc			ImageStampAddLine;

ImageStampGetHDCFunc			ImageStampGetHDC;
ImageStampReleaseHDCFunc		ImageStampReleaseHDC;

VeryShellPrintPDFFileFunc		VeryShellPrintPDFFile;
VeryShellPrintPDFFileTimeOutFunc VeryShellPrintPDFFileTimeOut;
VeryShellPrintPDFFileMarginsFunc VeryShellPrintPDFFileMargins;

VeryRunCommand			pVeryRunCommand;
VeryGetPDFFileMediaBox	pVeryGetPDFFileMediaBox;
void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
void FreeVeryWDll()
{
	if(g_hVeryW==NULL)
		return ;
	FreeLibrary(g_hVeryW);
	g_hVeryW=NULL;
}

BOOL LoadVeryWDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"verywrite.dll");
	g_hVeryW=LoadLibrary(path);
	if(g_hVeryW==NULL)
		goto Failer;

	ImageStampOpen = (ImageStampOpenFunc)GetProcAddress(g_hVeryW,"ImageStampOpen");
	if(ImageStampOpen == NULL)
		goto Failer;
	ImageStampClose = (ImageStampCloseFunc)GetProcAddress(g_hVeryW,"ImageStampClose");
	if(ImageStampClose == NULL)
		goto Failer;
	ImageStampAddText = (ImageStampAddTextFunc)GetProcAddress(g_hVeryW,"ImageStampAddText");
	if(ImageStampAddText == NULL)
		goto Failer;
	ImageStampAddImage = (ImageStampAddImageFunc)GetProcAddress(g_hVeryW,"ImageStampAddImage");
	if(ImageStampAddImage == NULL)
		goto Failer;
	ImageStampGetInfo = (ImageStampGetInfoFunc)GetProcAddress(g_hVeryW,"ImageStampGetInfo");
	if(ImageStampGetInfo == NULL)
		goto Failer;
	ImageStampPrint = (ImageStampPrintFunc)GetProcAddress(g_hVeryW,"ImageStampPrint");
	if(ImageStampPrint == NULL)
		goto Failer;
	ImageStampPrintEx = (ImageStampPrintExFunc)GetProcAddress(g_hVeryW,"ImageStampPrintEx");
	if(ImageStampPrintEx == NULL)
		goto Failer;
	ImageStampSetPageRange = (ImageStampSetPageRangeFunc)GetProcAddress(g_hVeryW,"ImageStampSetPageRange");
	if(ImageStampSetPageRange == NULL)
		goto Failer;

	ImageStampCloseAndNotSave = (ImageStampCloseAndNotSaveFunc)GetProcAddress(g_hVeryW,"ImageStampCloseAndNotSave");
	if(ImageStampCloseAndNotSave == NULL)
		goto Failer;
	ImageStampShow = (ImageStampShowFunc)GetProcAddress(g_hVeryW,"ImageStampShow");
	if(ImageStampShow == NULL)
		goto Failer;
	ImageStampSetLibDirectoryName = (ImageStampSetLibDirectoryNameFunc)GetProcAddress(g_hVeryW,"ImageStampSetLibDirectoryName");
	if(ImageStampSetLibDirectoryName == NULL)
		goto Failer;
	ImageStampAddLine = (ImageStampAddLineFunc)GetProcAddress(g_hVeryW,"ImageStampAddLine");
	if(ImageStampAddLine == NULL)
		goto Failer;

	ImageStampGetHDC = (ImageStampGetHDCFunc)GetProcAddress(g_hVeryW,"ImageStampGetHDC");
	if(ImageStampGetHDC == NULL)
		goto Failer;
	ImageStampReleaseHDC = (ImageStampReleaseHDCFunc)GetProcAddress(g_hVeryW,"ImageStampReleaseHDC");
	if(ImageStampReleaseHDC == NULL)
		goto Failer;
	VeryShellPrintPDFFile = (VeryShellPrintPDFFileFunc)GetProcAddress(g_hVeryW,"VeryShellPrintPDFFile");
	if(VeryShellPrintPDFFile == NULL)
		goto Failer;
	VeryShellPrintPDFFileTimeOut = (VeryShellPrintPDFFileTimeOutFunc)GetProcAddress(g_hVeryW,"VeryShellPrintPDFFileTimeOut");
	if(VeryShellPrintPDFFileTimeOut == NULL)
		goto Failer;
	VeryShellPrintPDFFileMargins = (VeryShellPrintPDFFileMarginsFunc)GetProcAddress(g_hVeryW,"VeryShellPrintPDFFileMargins");
	if(VeryShellPrintPDFFileMargins == NULL)
		goto Failer;
	pVeryGetPDFFileMediaBox=(VeryGetPDFFileMediaBox)GetProcAddress(g_hVeryW,"VeryGetPDFFileMediaBox");
	if(pVeryGetPDFFileMediaBox==NULL)
		goto Failer;
	pVeryRunCommand = (VeryRunCommand)GetProcAddress(g_hVeryW,"VeryRunCommand");
	if(pVeryRunCommand == NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeVeryWDll(); 
	return FALSE;

}

int main(int argc, char* argv[])
{
	if(!LoadVeryWDll())
		return 0;

	LOGFONT m_font;
	memset(&m_font,0,sizeof(LOGFONT));

	char szInTIFFName[MAX_PATH];
	GetModulePath(szInTIFFName,"multipage.tif");
	char szOutTIFFName[MAX_PATH];
	GetModulePath(szOutTIFFName,"example_stamp.tif");

	//Stamp text&image into a TIFF file, get info from a TIFF file, print a TIFF file
	if(1)
	{
		//Add a text stamp into TIFF file
		strcpy(m_font.lfFaceName,"Arial");
		m_font.lfHeight = 200;
		long id = ImageStampOpen(szInTIFFName,szOutTIFFName);
		if(id < 0)
			return 0;
		ImageStampAddText(id,100,100,"This is a test!",RGB(0,0,0),m_font,0);
		
		m_font.lfEscapement = m_font.lfOrientation = 45*10;
		m_font.lfHeight = 150;
		ImageStampAddText(id,100,500,"This is a test!",RGB(0,0,0),m_font,1);

		//Add an image stamp into TIFF file
		char szInExampleName1[MAX_PATH];
		GetModulePath(szInExampleName1,"logo.jpg");
		ImageStampAddImage(id,0,0,100,100,szInExampleName1,TRUE);

		char szInExampleName2[MAX_PATH];
		GetModulePath(szInExampleName2,"test1.jpg");
		ImageStampAddImage(id,300,300,100,100,szInExampleName2,TRUE);

		ImageStampAddLine(id,100,100,800,800,5,RGB(255,0,0),PS_SOLID);

		ImageStampAddLine(id,100,500,800,800,10,RGB(0,0,0),PS_DASH);

		//Get Image Info from TIFF file
		BITMAPINFOHEADER infoHeader;
		ImageStampGetInfo(id,&infoHeader);

		//Print Current TIFF Image
		ImageStampPrint(id,"docPrint",DMORIENT_PORTRAIT,DMPAPER_A4,3);

		HDC m_tmpDC = ImageStampGetHDC(id);
		if(m_tmpDC)
		{
			char *m_pText = "ImageStampGetHDC() Test...";
			TextOut(m_tmpDC,100,100,m_pText,strlen(m_pText));
			ImageStampReleaseHDC(id,m_tmpDC);
			m_tmpDC = NULL;
		}

		ImageStampClose(id);

		ShellExecute(NULL,"open",szOutTIFFName,NULL,NULL,SW_SHOWNORMAL);
	}
	MessageBox(NULL,"Please click any key to continue ...","Prompt",MB_OK);
	//Show a TIFF file and a PDF file
	{
		char szInExampleName1[MAX_PATH];
		GetModulePath(szInExampleName1,"example.pdf");
		long id = ImageStampOpen(szInExampleName1,NULL);
		if(id < 0)
			return 0;
		//Show PDF file on an output-device
		HDC hDC = GetDC(NULL);
		RECT m_rectDest = {0,0,300,300};
		ImageStampShow(id,hDC,&m_rectDest,NULL);
		ReleaseDC(NULL,hDC);

		VeryShellPrintPDFFileTimeOut(2*1000);  //Check Printing status after 2 seconds
		VeryShellPrintPDFFileMargins(50);      //Set the margins to 50 point
		//Print Current PDF file
		ImageStampSetPageRange(id,"2,5"); //You can print a special page range at here
		ImageStampPrint(id,"docPrint",DMORIENT_LANDSCAPE,DMPAPER_A4,3);
		//Close PDF file and doesn't change anything
		ImageStampCloseAndNotSave(id);
	}
	FreeVeryWDll();
	return 0;
}
